function RR_LootWindowEvent()


	ChatFrame1:AddMessage(event)
	ChatFrame1:AddMessage(arg1)
	ChatFrame1:AddMessage(arg2)

	if event == "LOOT_OPENED" then
		player_name = UnitName("player"); 
		mob_name = UnitName("target"); 
		mob_guid = UnitGUID("target");
		
	-- Check if we are looking at a mob
		if mob_guid ~= nil then
			ChatFrame1:AddMessage(mob_name.." has the GUID: "..mob_guid);
			
		-- Create an array for the mob GUID
			if RaidRoll_DB["Loot"][mob_guid] == nil then RaidRoll_DB["Loot"][mob_guid] = {} end
			
			
			if RaidRoll_DB["Loot"][mob_guid]["ALREADY FOUND"] == nil then
				
			-- Set it so that we know the mob has been found
				RaidRoll_DB["Loot"][mob_guid]["ALREADY FOUND"] = true
				ChatFrame1:AddMessage("New Mob Found!")
				
			-- Get the number of items on the body
				numLootItems = GetNumLootItems();
				
				LootNumber = 0
				
			-- Check if the mob has loots
				if numLootItems ~= nil then
					ChatFrame1:AddMessage("The Mob Has Loots!")
					ChatFrame1:AddMessage(numLootItems)
					
				-- Used later to see if an item was found yet
					WeHaveFoundAnItem = false
					
				-- Start scanning for items
					for i=1,numLootItems do
					-- If its an item
						if LootSlotIsItem(i) then
							if WeHaveFoundAnItem == false then
							-- If we are currently looking at the last window
								if RaidRoll_DB["Loot"]["TOTAL WINDOWS"] == RaidRoll_DB["Loot"]["CURRENT WINDOW"] then
								--then increment the current window ID
									RaidRoll_DB["Loot"]["CURRENT WINDOW"] = RaidRoll_DB["Loot"]["CURRENT WINDOW"] + 1
								end
								
							-- Add a window to the list of windows
								RaidRoll_DB["Loot"]["TOTAL WINDOWS"] = RaidRoll_DB["Loot"]["TOTAL WINDOWS"] + 1
								Max_LootID = RaidRoll_DB["Loot"]["TOTAL WINDOWS"]
								
								
							-- Set the Identifier to the mob guid
								if RaidRoll_DB["Loot"][Max_LootID] == nil then RaidRoll_DB["Loot"][Max_LootID] = mob_guid end
								
								WeHaveFoundAnItem = true
							end
							
							--for j=1,10 do
								
							-- Increase the count by 1 (because an item was found)
								LootNumber = LootNumber + 1
								
							-- Get the ICON and ITEMLINK
								lootIcon, lootName, lootQuantity, rarity = GetLootSlotInfo(i);
								ItemLink = GetLootSlotLink(i); 
								
								
								
								
								RaidRoll_DB["Loot"][mob_guid]["LOOTER NAME"] 	= player_name
								RaidRoll_DB["Loot"][mob_guid]["MOB NAME"] 		= mob_name
								RaidRoll_DB["Loot"][mob_guid]["TOTAL ITEMS"] 	= LootNumber
								
								
								if RaidRoll_DB["Loot"][mob_guid]["ITEM_" .. LootNumber] == nil then RaidRoll_DB["Loot"][mob_guid]["ITEM_" .. LootNumber] = {} end
								
								RaidRoll_DB["Loot"][mob_guid]["ITEM_" .. LootNumber]["ITEMLINK"] 	= ItemLink
								RaidRoll_DB["Loot"][mob_guid]["ITEM_" .. LootNumber]["ICON"]		= lootIcon
								RaidRoll_DB["Loot"][mob_guid]["ITEM_" .. LootNumber]["WINNER"]		= "-"
								RaidRoll_DB["Loot"][mob_guid]["ITEM_" .. LootNumber]["RECEIVED"]	= "-"
							--end
							
							
							ChatFrame1:AddMessage(ItemLink)
							
							ChatFrame1:AddMessage(lootIcon)
							ChatFrame1:AddMessage(lootName)
							ChatFrame1:AddMessage(lootQuantity)
							ChatFrame1:AddMessage(rarity)	
							
							RR_Loot_Display_Refresh()						
						end
					end
				end	
			end
		end
	end
end


-- sets up the loot frame
function RR_SetupLootFrame()

--Clear the database (debugging)
--RaidRoll_DB["Loot"] = {}

if RaidRoll_DB["Loot"] == nil then RaidRoll_DB["Loot"] = {} end
if RaidRoll_DB["Loot"]["TOTAL WINDOWS"] == nil then RaidRoll_DB["Loot"]["TOTAL WINDOWS"] = 0 end
if RaidRoll_DB["Loot"]["CURRENT WINDOW"] == nil then RaidRoll_DB["Loot"]["CURRENT WINDOW"] = 0 end





-- Hook Looting events
 local RR_LootEventHook = CreateFrame("Frame")
 
  RR_LootEventHook:RegisterEvent("LOOT_OPENED")
  
 RR_LootEventHook:SetScript("OnEvent", RR_LootWindowEvent)
  
  
  
  

--RR_LOOT_FRAME = CreateFrame("Frame","RR_LOOT_FRAME",UIParent)

rr_default_backdrop = {
  --bgFile="Interface\DialogFrame\UI-DialogBox-Background",  -- path to the background texture
  --edgeFile="Interface\DialogFrame\UI-DialogBox-Border",  -- path to the border texture
  
	bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",  -- path to the background texture
	edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",  -- path to the border texture
  
  tile = true,    -- true to repeat the background texture to fill the frame, false to scale it
  tileSize = 32,  -- size (width or height) of the square repeating background tiles (in pixels)
  edgeSize = 20,  -- thickness of edge segments and square size of edge corners (in pixels)
  insets = {    -- distance from the edges of the frame to those of the background texture (in pixels)
    left = 2,
    right = 2,
    top = 2,
    bottom = 2
  }
}

RR_LOOT_FRAME:SetBackdrop(rr_default_backdrop)




RR_LOOT_FRAME:SetFrameStrata("MEDIUM")
RR_LOOT_FRAME:SetWidth(260) -- Set these to whatever height/width is needed 
RR_LOOT_FRAME:SetHeight(270) -- Set these to whatever height/width is needed 
	

--RR_LOOT_FRAME:ClearAllPoints(); 
--RR_LOOT_FRAME:SetPoint("CENTER")


-- Debugging, auto-show the loot window
	if RaidRoll_DB["debug"] == true then RR_LOOT_FRAME:Show() end

RR_LOOT_FRAME:SetMovable(true)
RR_LOOT_FRAME:EnableMouse(true)
RR_LOOT_FRAME:SetScript("OnMouseDown",function()
  RR_LOOT_FRAME:StartMoving()
end)
RR_LOOT_FRAME:SetScript("OnMouseUp",function()
  RR_LOOT_FRAME:StopMovingOrSizing()
end)

ChatFrame1:AddMessage("Loot Frame - Loaded")

if RR_LOOT_FRAME:IsShown() then
	ChatFrame1:AddMessage("Loot Frame - Shown")
end





-- Create 5 strings and a header for the guild ranks
	Raid_Roll_Loot=CreateFrame("FRAME","Raid_Roll_Loot",RR_LOOT_FRAME);
	
	RR_Loot_String_WindowName = Raid_Roll_Loot:CreateFontString("Window Name","ARTWORK","GameFontNormal");
	RR_Loot_String_WindowName:SetPoint("TOPLEFT",RR_LOOT_FRAME,"TOPLEFT", 8, -8);
	RR_Loot_String_WindowName:SetJustifyH("LEFT")
	RR_Loot_String_WindowName:SetText("Killerpet's Loot Tracker")
	
	RR_Loot_String_MobName = Raid_Roll_Loot:CreateFontString("Mob Name","ARTWORK","GameFontNormal");
	RR_Loot_String_MobName:SetPoint("TOPLEFT",RR_LOOT_FRAME,"TOPLEFT", 8, -210);
	RR_Loot_String_MobName:SetJustifyH("LEFT")
	RR_Loot_String_MobName:SetText("Mob Name:")
	
	RR_Loot_String_LooterName = Raid_Roll_Loot:CreateFontString("Looter Name","ARTWORK","GameFontNormal");
	RR_Loot_String_LooterName:SetPoint("TOPLEFT",RR_LOOT_FRAME,"TOPLEFT", 8, -230);
	RR_Loot_String_LooterName:SetJustifyH("LEFT")
	RR_Loot_String_LooterName:SetText("Looter Name:")
	
--------------------THE BUTTONS   [<<] [<]   [>] [>>]--------------------
	RR_Loot_ButtonFirst = CreateFrame("Button", "RaidRoll_OptionButton", RR_LOOT_FRAME, "UIPanelButtonTemplate")
	RR_Loot_ButtonFirst:SetWidth(40)
	RR_Loot_ButtonFirst:SetHeight(20)
	RR_Loot_ButtonFirst:SetPoint("BottomLEFT", RR_LOOT_FRAME, "BottomLEFT", 5, 5)
	RR_Loot_ButtonFirst:SetText("<<")
	RR_Loot_ButtonFirst:SetScript("OnClick",function() RR_Loot_GotoWindow("First") end)
	
	RR_Loot_ButtonPrev = CreateFrame("Button", "RaidRoll_OptionButton", RR_LOOT_FRAME, "UIPanelButtonTemplate")
	RR_Loot_ButtonPrev:SetWidth(40)
	RR_Loot_ButtonPrev:SetHeight(20)
	RR_Loot_ButtonPrev:SetPoint("BottomLEFT", RR_LOOT_FRAME, "BottomLEFT", 50, 5)
	RR_Loot_ButtonPrev:SetText("<")
	RR_Loot_ButtonPrev:SetScript("OnClick",function() RR_Loot_GotoWindow("Prev") end)
	
	RR_Loot_ButtonNext = CreateFrame("Button", "RaidRoll_OptionButton", RR_LOOT_FRAME, "UIPanelButtonTemplate")
	RR_Loot_ButtonNext:SetWidth(40)
	RR_Loot_ButtonNext:SetHeight(20)
	RR_Loot_ButtonNext:SetPoint("BottomLEFT", RR_LOOT_FRAME, "BottomLEFT", 95, 5)
	RR_Loot_ButtonNext:SetText(">")
	RR_Loot_ButtonNext:SetScript("OnClick",function() RR_Loot_GotoWindow("Next") end)
	
	RR_Loot_ButtonLast = CreateFrame("Button", "RaidRoll_OptionButton", RR_LOOT_FRAME, "UIPanelButtonTemplate")
	RR_Loot_ButtonLast:SetWidth(40)
	RR_Loot_ButtonLast:SetHeight(20)
	RR_Loot_ButtonLast:SetPoint("BottomLEFT", RR_LOOT_FRAME, "BottomLEFT", 140, 5)
	RR_Loot_ButtonLast:SetText(">>")
	RR_Loot_ButtonLast:SetScript("OnClick",function() RR_Loot_GotoWindow("Last") end)
	
	RR_Loot_ButtonMinMax = CreateFrame("Button", "RaidRoll_OptionButton", RR_LOOT_FRAME, "UIPanelButtonTemplate")
	RR_Loot_ButtonMinMax:SetWidth(30)
	RR_Loot_ButtonMinMax:SetHeight(20)
	RR_Loot_ButtonMinMax:SetPoint("BottomLEFT", RR_LOOT_FRAME, "BottomLEFT", 200, 5)
	RR_Loot_ButtonMinMax:SetText("Min")
	RR_Loot_ButtonMinMax:SetScript("OnClick",function() RR_Loot_WindowChangeSize("Min","Bottom") end)
	
	RR_Loot_ButtonMinMaxTop = CreateFrame("Button", "RaidRoll_OptionButton", RR_LOOT_FRAME, "UIPanelButtonTemplate")
	RR_Loot_ButtonMinMaxTop:SetWidth(30)
	RR_Loot_ButtonMinMaxTop:SetHeight(20)
	RR_Loot_ButtonMinMaxTop:SetPoint("TopLEFT", RR_LOOT_FRAME, "TopLEFT", 200, -5)
	RR_Loot_ButtonMinMaxTop:SetText("Min")
	RR_Loot_ButtonMinMaxTop:SetScript("OnClick",function() RR_Loot_WindowChangeSize("Min","Top") end)
	

	
--------------------THE SLIDER BAR--------------------------------

 RaidRoll_Loot_Slider = CreateFrame("Slider", "RaidRoll_Loot_Slider_ID", RR_LOOT_FRAME, "OptionsSliderTemplate")
 RaidRoll_Loot_Slider:SetWidth(10)
 RaidRoll_Loot_Slider:SetHeight(RR_LOOT_FRAME:GetHeight() - 30 )
 RaidRoll_Loot_Slider:SetPoint('TOPRIGHT', -8, -25)
 RaidRoll_Loot_Slider:SetOrientation('VERTICAL')
 

 getglobal(RaidRoll_Loot_Slider:GetName() .. 'Low'):SetText('');
 getglobal(RaidRoll_Loot_Slider:GetName() .. 'High'):SetText(''); 
 getglobal(RaidRoll_Loot_Slider:GetName() .. 'Text'):SetText('');


 
 RaidRoll_Loot_Slider:SetMinMaxValues(1, 1)
 RaidRoll_Loot_Slider:SetValueStep(1)
 RaidRoll_Loot_Slider:SetValue(1)

 RaidRoll_Loot_Slider:Show()
 
 
  RaidRoll_Loot_Slider:SetScript("OnValueChanged",function()
	RaidRoll_Loot_Slider_Window_Scroll(0)
  end)
 
 ----------------------------------------------------
 
 -- This allows scrolling and passes arg1 (the direction of the scrolling [1 or -1] )
RR_LOOT_FRAME:EnableMouseWheel(1)
 RR_LOOT_FRAME:SetScript("OnMouseWheel",function()
  RaidRoll_Loot_Slider_Window_Scroll(arg1)
end)

-------------------------------------------------------------

 Close_Button = CreateFrame("Button", "Close_Button", RR_LOOT_FRAME, "UIPanelCloseButton")
 Close_Button:SetWidth(30)
 Close_Button:SetHeight(30)
 Close_Button:SetPoint("TOPRIGHT", RR_LOOT_FRAME, "TOPRIGHT", -0, -0)

--------------------------------------------------------------------------------------------------------
	
	-- Create frames which will be used for items
	for i=1,4 do
		RR_Loot_Name_String_i = Raid_Roll_Loot:CreateFontString("RR_Loot_Name_String"..i ,"ARTWORK","GameFontNormal");
		RR_Loot_Name_String_i:SetPoint("TOPLEFT",RR_LOOT_FRAME,"TOPLEFT", 45, 20 - (i*45));
		RR_Loot_Name_String_i:SetJustifyH("LEFT")
		RR_Loot_Name_String_i:SetWidth(200); 
		RR_Loot_Name_String_i:SetText("Item "..i)
		
		RR_Loot_Won_String_i = Raid_Roll_Loot:CreateFontString("RR_Loot_Won_String"..i ,"ARTWORK","GameFontNormal");
		RR_Loot_Won_String_i:SetPoint("TOPLEFT",RR_Loot_Name_String_i,"TOPLEFT", 0, -12);
		RR_Loot_Won_String_i:SetJustifyH("LEFT")
		RR_Loot_Won_String_i:SetWidth(200); 
		RR_Loot_Won_String_i:SetText("Won Item: "..i)
		
		RR_Loot_Received_String_i = Raid_Roll_Loot:CreateFontString("RR_Loot_Received_String"..i ,"ARTWORK","GameFontNormal");
		RR_Loot_Received_String_i:SetPoint("TOPLEFT",RR_Loot_Won_String_i,"TOPLEFT", 0, -12);
		RR_Loot_Received_String_i:SetJustifyH("LEFT")
		RR_Loot_Received_String_i:SetWidth(200); 
		RR_Loot_Received_String_i:SetText("Received: "..i)
		
		RR_LootIcon = CreateFrame("Button","RR_LootIcon"..i,RR_LOOT_FRAME)
		--RR_LootIcon:SetFrameStrata("FULLSCREEN")
		RR_LootIcon:SetWidth(40) -- Set these to whatever height/width is needed 
		RR_LootIcon:SetHeight(40) -- Set these to whatever height/width is needed 
		--RR_LootIcon:ClearAllPoints(); 
		RR_LootIcon:SetPoint("TopLeft", "RR_LOOT_FRAME", "TopLeft", 5, 20 - (i*45))
		RR_LootIcon:SetBackdrop(rr_default_backdrop)
		--RR_LootIcon:Show()
		
		RR_LootIcon:SetScript("OnEnter", function(self) RR_MouseOver(self:GetName())	end)
		RR_LootIcon:SetScript("OnLeave", function() GameTooltip:Hide()	end)
	end	
	
	RR_Loot_CurrentVsMaxWindow = Raid_Roll_Loot:CreateFontString("RR_Loot_CurrentVsMaxWindow_String" ,"ARTWORK","GameFontNormal");
	RR_Loot_CurrentVsMaxWindow:SetPoint("topLEFT",RR_LOOT_FRAME,"topLEFT", 155, -8);
	RR_Loot_CurrentVsMaxWindow:SetJustifyH("LEFT")
	RR_Loot_CurrentVsMaxWindow:SetWidth(60); 
	RR_Loot_CurrentVsMaxWindow:SetText("0/0")

	RR_Loot_Display_Refresh()
end

function RR_Loot_GotoWindow(WhichWindow)

	if RaidRoll_DB["Loot"]["TOTAL WINDOWS"] ~= 0 then
		if WhichWindow == "First" then
			RaidRoll_DB["Loot"]["CURRENT WINDOW"] = 1
		elseif WhichWindow == "Prev" then
			if RaidRoll_DB["Loot"]["CURRENT WINDOW"] > 1 then
				RaidRoll_DB["Loot"]["CURRENT WINDOW"] = RaidRoll_DB["Loot"]["CURRENT WINDOW"] - 1
			end
		elseif WhichWindow == "Next" then
			if RaidRoll_DB["Loot"]["CURRENT WINDOW"] < RaidRoll_DB["Loot"]["TOTAL WINDOWS"] then
				RaidRoll_DB["Loot"]["CURRENT WINDOW"] = RaidRoll_DB["Loot"]["CURRENT WINDOW"] + 1
			end
		elseif WhichWindow == "Last" then
			RaidRoll_DB["Loot"]["CURRENT WINDOW"] = RaidRoll_DB["Loot"]["TOTAL WINDOWS"]
		end
	end
	RaidRoll_Loot_Slider:SetValue(1)
	
	RR_Loot_Display_Refresh()
	
	if RaidRoll_DB["debug"] == true then 
		if RaidRoll_DB["Loot"]["CURRENT WINDOW"] 	~= nil then ChatFrame1:AddMessage("Current: " .. RaidRoll_DB["Loot"]["CURRENT WINDOW"]) end
		if RaidRoll_DB["Loot"]["TOTAL WINDOWS"] 	~= nil then ChatFrame1:AddMessage("Total:   " .. RaidRoll_DB["Loot"]["TOTAL WINDOWS"] ) end
	end
end


-- Come back to this
function RaidRoll_Loot_Slider_Window_Scroll(direction)

	if RaidRoll_DB["Loot"]["TOTAL WINDOWS"] ~= 0 then
		-- Debugging, shows the direction and value
		if RaidRoll_DB["debug"] == true then ChatFrame1:AddMessage(direction) end
		if RaidRoll_DB["debug"] == true then ChatFrame1:AddMessage(RaidRoll_Loot_Slider:GetValue()) end
		
		MOB_ID = RaidRoll_DB["Loot"][Current_Window]
		Current_Window = RaidRoll_DB["Loot"]["CURRENT WINDOW"]
		
		if RaidRoll_DB["Loot"][MOB_ID]["TOTAL ITEMS"] >= 4 then
			Loot_MaxNumber = RaidRoll_DB["Loot"][MOB_ID]["TOTAL ITEMS"] - 3
		else
			Loot_MaxNumber = 1
		end
		
		RaidRoll_Loot_Slider:SetMinMaxValues(1, Loot_MaxNumber)
		
		
		RaidRoll_Loot_Slider:SetValue(RaidRoll_Loot_Slider:GetValue() - (direction * 2))
		
		if RaidRoll_Loot_Slider:GetValue() > Loot_MaxNumber then
			RaidRoll_Loot_Slider:SetValue(Loot_MaxNumber)
		end
		
		RR_ScrollOffset = RaidRoll_Loot_Slider:GetValue() - 1
	 
		RR_Loot_Display_Refresh()
	end
	
	if GetMouseFocus():GetName() == "RR_LootIcon1" or GetMouseFocus():GetName() == "RR_LootIcon2" or GetMouseFocus():GetName() == "RR_LootIcon3" or GetMouseFocus():GetName() == "RR_LootIcon4" then
		RR_MouseOver(GetMouseFocus():GetName())
	end
end


function RR_Loot_Display_Refresh()

Current_Window = RaidRoll_DB["Loot"]["CURRENT WINDOW"]

	if Current_Window ~= 0 then
	--Get the mob id for the current window
		MOB_ID = RaidRoll_DB["Loot"][Current_Window]

		for i=1,4 do
			if i <= RaidRoll_DB["Loot"][MOB_ID]["TOTAL ITEMS"] then
			--Get the slider offset
				j = i + RaidRoll_Loot_Slider:GetValue() - 1
				
				MobName		= RaidRoll_DB["Loot"][MOB_ID]["MOB NAME"]
				LooterName	= RaidRoll_DB["Loot"][MOB_ID]["LOOTER NAME"]
				
				ItemLink 	= RaidRoll_DB["Loot"][MOB_ID]["ITEM_"..j]["ITEMLINK"]
				ItemIcon 	= RaidRoll_DB["Loot"][MOB_ID]["ITEM_"..j]["ICON"]
				Winner 		= RaidRoll_DB["Loot"][MOB_ID]["ITEM_"..j]["WINNER"]
				Received 	= RaidRoll_DB["Loot"][MOB_ID]["ITEM_"..j]["RECEIVED"]
				
				
				getglobal("RR_Loot_Name_String"..i):SetText(ItemLink)
				getglobal("RR_LootIcon"..i):SetBackdrop( {bgFile = ItemIcon	})
				getglobal("RR_Loot_Won_String"..i):SetText("Won Item: " .. Winner)
				getglobal("RR_Loot_Received_String"..i):SetText("Received: " .. Received)
				
				RR_Loot_String_MobName:SetText("Mob Name: ".. MobName)
				RR_Loot_String_LooterName:SetText("Looter Name: ".. LooterName)
				
				RR_Loot_CurrentVsMaxWindow:SetText(RaidRoll_DB["Loot"]["CURRENT WINDOW"].."/"..RaidRoll_DB["Loot"]["TOTAL WINDOWS"])
			else
				getglobal("RR_Loot_Name_String"..i):SetText("")
				getglobal("RR_LootIcon"..i):SetBackdrop(rr_default_backdrop)
				getglobal("RR_Loot_Won_String"..i):SetText("Won Item: ")
				getglobal("RR_Loot_Received_String"..i):SetText("Received: ")
				
			end
		end
	end
end

function RR_MouseOver(ID)

	--ChatFrame1:AddMessage(ID)

	if ID == "RR_LootIcon1" then i = 1 end
	if ID == "RR_LootIcon2" then i = 2 end
	if ID == "RR_LootIcon3" then i = 3 end
	if ID == "RR_LootIcon4" then i = 4 end
	
	j = i + RaidRoll_Loot_Slider:GetValue() - 1

	Current_Window = RaidRoll_DB["Loot"]["CURRENT WINDOW"]
	MOB_ID = RaidRoll_DB["Loot"][Current_Window]

	GameTooltip_SetDefaultAnchor( GameTooltip, UIParent )
	GameTooltip:ClearAllPoints(); 
	GameTooltip:SetPoint("bottomleft", getglobal(ID), "topright", 0, 0)
	GameTooltip:ClearLines()
	
	if RaidRoll_DB["Loot"][MOB_ID] ~= nil then
		if RaidRoll_DB["Loot"][MOB_ID]["ITEM_"..j] ~= nil then
			GameTooltip:SetHyperlink(RaidRoll_DB["Loot"][MOB_ID]["ITEM_"..j]["ITEMLINK"])
		end
	end
end 



function RR_Loot_WindowChangeSize(MinMax,TopBottom)

BottomLoc 	= RR_LOOT_FRAME:GetBottom();
xoff = RR_LOOT_FRAME:GetLeft()


ChatFrame1:AddMessage("-----")
ChatFrame1:AddMessage(xoff)
ChatFrame1:AddMessage(BottomLoc)

ChatFrame1:AddMessage("-------")
point, relativeTo, relativePoint, xOfs, yOfs = RR_LOOT_FRAME:GetPoint()
DEFAULT_CHAT_FRAME:AddMessage(point)
DEFAULT_CHAT_FRAME:AddMessage(relativeTo)
DEFAULT_CHAT_FRAME:AddMessage(relativePoint)
DEFAULT_CHAT_FRAME:AddMessage(xOfs)
DEFAULT_CHAT_FRAME:AddMessage(yOfs)
ChatFrame1:AddMessage("---------")




	if MinMax == "Min" then
		RR_Loot_ButtonMinMax:SetText("Max")
		RR_Loot_ButtonMinMax:SetScript("OnClick",function() RR_Loot_WindowChangeSize("Max") end)
		RR_LOOT_FRAME:SetHeight(30)
		
		RR_Loot_ButtonMinMaxTop:Hide()
		
		for i=1,4 do
			getglobal("RR_Loot_Name_String" .. i):Hide()
			getglobal("RR_Loot_Won_String" .. i):Hide() 
			getglobal("RR_Loot_Received_String" .. i):Hide()
			getglobal("RR_LootIcon"..i):Hide()
			
			RR_Loot_String_MobName:Hide()
			RR_Loot_String_LooterName:Hide()
			
			RR_Loot_ButtonFirst:Hide()
			RR_Loot_ButtonPrev:Hide()
			RR_Loot_ButtonNext:Hide()
			RR_Loot_ButtonLast:Hide()
			
			RaidRoll_Loot_Slider:Hide()
		end	
		
	end
	
	if MinMax == "Max" then
		RR_Loot_ButtonMinMax:SetText("Min")
		RR_Loot_ButtonMinMax:SetScript("OnClick",function() RR_Loot_WindowChangeSize("Min") end)
		RR_LOOT_FRAME:SetHeight(270)
		
		RR_Loot_ButtonMinMaxTop:Show()
		
		for i=1,4 do
			getglobal("RR_Loot_Name_String" .. i):Show()
			getglobal("RR_Loot_Won_String" .. i):Show() 
			getglobal("RR_Loot_Received_String" .. i):Show()
			getglobal("RR_LootIcon"..i):Show()
			
			RR_Loot_String_MobName:Show()
			RR_Loot_String_LooterName:Show()
			
			RR_Loot_ButtonFirst:Show()
			RR_Loot_ButtonPrev:Show()
			RR_Loot_ButtonNext:Show()
			RR_Loot_ButtonLast:Show()
			
			RaidRoll_Loot_Slider:Show()
		end	
		
	end
	
	if TopBottom == "Top" then
		RR_LOOT_FRAME:ClearAllPoints()
		RR_LOOT_FRAME:SetPoint("CENTER", nil, "topleft", xoff + (RR_LOOT_FRAME:GetWidth()/2),BottomLoc + (RR_LOOT_FRAME:GetHeight()/2))
	else
		RR_LOOT_FRAME:ClearAllPoints()
		RR_LOOT_FRAME:SetPoint("CENTER", nil, "bottomleft", xoff + (RR_LOOT_FRAME:GetWidth()/2),BottomLoc + (RR_LOOT_FRAME:GetHeight()/2))	
	end
	
	RR_LOOT_FRAME:ClearAllPoints()
	RR_LOOT_FRAME:SetPoint("CENTER", nil, "bottomleft", xoff + (RR_LOOT_FRAME:GetWidth()/2),BottomLoc + (RR_LOOT_FRAME:GetHeight()/2))
	
	
	
	
	


end 