--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

function RR_Test()
	ChatFrame1:AddMessage("Kilerpet's Raid Roll Addon - Loaded")
end

function RR_SetupSlashCommands()
 SLASH_RR1 = "/rr";
 SLASH_RR2 = "/raidroll";
 SLASH_RR3 = "/rrl";
 
 
 SlashCmdList["RR"] =  RR_Command;
end

function RaidRoll_OnLoad()

ChatFrame1:AddMessage("Kilerpet's Raid Roll Addon - Loaded x")


 
 RR_Test()
 
 
 local f = CreateFrame("Frame")
 
  f:RegisterEvent("CHAT_MSG_SYSTEM")
  
  f:RegisterEvent("CHAT_MSG_PARTY")
  f:RegisterEvent("CHAT_MSG_RAID")
  f:RegisterEvent("CHAT_MSG_RAID_LEADER")
  f:RegisterEvent("CHAT_MSG_RAID_WARNING")
  f:RegisterEvent("CHAT_MSG_SAY")
  f:RegisterEvent("CHAT_MSG_YELL")
  f:RegisterEvent("CHAT_MSG_ADDON")
  f:RegisterEvent("ADDON_LOADED"); 
  f:RegisterEvent("VARIABLES_LOADED");-- Fired when saved variables are loaded

  
  
  f:SetScript("OnEvent", RaidRoll_Event)
  
  RR_Has_Rolled = false
  RR_Rolling_on_item = true
  
  rr_rollID = 0
  rr_CurrentRollID = 0
  
  RR_ScrollOffset = 0
  
-- Define the various arrays
  rr_Roll = {}
  rr_PlayersRolled = {}
  rr_Item = {}
  rr_playername = {}
  RollerRoll = {}
  RollerName = {}
  RollerGroup = {}
  MaxPlayers = {}
  RollerFirst = {}
  RollerRank = {}
  RollerRankIndex = {}
  HasRolled = {}
  Roll_Number = {}
  RR_LegitRoll = {}
  RaidRoll_LegitRoll = {}
  RR_NameMark = {}

  


  rr_Item[0] = "ID #0"
  
  RollerName[0] = {}
  
  RollerName[0][1] = ""
  
  RR_Timestamp = 0
  
  RR_Doing_a_New_Roll = false
  
--[[
  local name  = UnitName("player")
  local realm = GetRealmName();
  
if realm == "Lightning's Blade" then
  SendAddonMessage( "RAIDROLL", name, "WHISPER", "Musoubank" );
  SendAddonMessage( "RAIDROLL", name, "WHISPER", "Killerpet" );
  SendAddonMessage( "RAIDROLL", name, "WHISPER", "Musou" );
  SendAddonMessage( "RAIDROLL", name, "WHISPER", "Sacrolash" );
  SendAddonMessage( "RAIDROLL", name, "WHISPER", "Kalya" );
  SendAddonMessage( "RAIDROLL", name, "WHISPER", "Netharel" );
end
]]

  

end

function RaidRoll_Window_Scroll(direction)

-- Debugging, shows the direction and value
if RaidRoll_DB["debug"] == true then ChatFrame1:AddMessage(direction) end
if RaidRoll_DB["debug"] == true then ChatFrame1:AddMessage(RaidRoll_Slider:GetValue()) end

-- Dont scroll unless a maxplayers value exists
	if MaxPlayers[rr_CurrentRollID] ~= nil then
		if MaxPlayers[rr_CurrentRollID] >= 5 then
			RaidRoll_MaxNumber = MaxPlayers[rr_CurrentRollID]-4
			RaidRoll_MaxNumber = MaxPlayers[rr_CurrentRollID]-4
		--else
			--RaidRoll_MaxNumber = 1
		--end
			
			RaidRoll_MaxNumber_Slider = RaidRoll_MaxNumber
			
			if rr_CurrentRollID > 0 and RaidRoll_MaxNumber > 1 then RaidRoll_MaxNumber_Slider = RaidRoll_MaxNumber - 1 end
			
			RaidRoll_Slider:SetMinMaxValues(1, RaidRoll_MaxNumber_Slider)
			
			
			RaidRoll_Slider:SetValue(RaidRoll_Slider:GetValue() - (direction * 3))
			
			if RaidRoll_Slider:GetValue() > RaidRoll_MaxNumber then
				RaidRoll_Slider:SetValue(RaidRoll_MaxNumber)
			end
			
			RR_ScrollOffset = RaidRoll_Slider:GetValue() - 1
			
			--for i=1, 5 do
				--if InviteHelper_Position[i+RaidRoll_Slider:GetValue()] ~= nil then
				--	getglobal("InviteHelper_GMButton_name" .. i):SetText(i+RaidRoll_Slider:GetValue() - 1 .. ": " .. RaidRoll_Position[i+RaidRoll_Slider:GetValue()])		
				--else
				--	getglobal("InviteHelper_GMButton_name" .. i):SetText("")	
				--end
			--end
			
		 --RaidRoll_Slider.tooltipText = RaidRoll_Slider:GetValue() .. " - " .. RaidRoll_Slider:GetValue() + 4
		 
			RR_Display(rr_CurrentRollID)
			
			
		end
	end
end

-- TOGGLE THE OPTIONS MENU
function RR_Roll_Options_Toggle()

	if RR_BottomFrame:IsShown() then
		getglobal("RaidRoll_Catch_All"):Hide()
		getglobal("RaidRoll_Allow_All"):Hide()
		RR_BottomFrame:Hide()
	else
		getglobal("RaidRoll_Catch_All"):Show()
		getglobal("RaidRoll_Allow_All"):Show()
		RR_BottomFrame:Show()
	end


end
----------------------------------------------------------------------------------------------

function RaidRoll_Event()

  
	if event == "CHAT_MSG_ADDON" and arg1 == "RAIDROLL" then
		ChatFrame1:AddMessage("|cFF11aacc" .. arg2 .. " found.")
		if RaidRoll_DB == nil then RaidRoll_DB = {} end
		if RaidRoll_DB["Amount"] == nil then RaidRoll_DB["Amount"] = 1 end
		if RaidRoll_DB["Names"] == nil then RaidRoll_DB["Names"] = {} end
		
		RR_CharacterWasFound = false
		
		for i=1,RaidRoll_DB["Amount"] do
			if RaidRoll_DB["Names"][i] == arg2 then RR_CharacterWasFound = true	end
		end
			
		if RR_CharacterWasFound == false then
			RaidRoll_DB["Names"][RaidRoll_DB["Amount"]] = arg2
			RaidRoll_DB["Amount"] = RaidRoll_DB["Amount"] + 1
		end
	end

		
-- Set up the variables with default values and set up the check boxes
	if event == "VARIABLES_LOADED" then
		RR_SetupVariables()	
		RR_SetupSlashCommands()
	end


-- Debugging, show the events that occured and the arguments
	if RaidRoll_DB ~= nil then
		if RaidRoll_DB["debug"] == true then 
			ChatFrame1:AddMessage("An event has occured")
			ChatFrame1:AddMessage(event) 
			if arg1 ~= nil then ChatFrame1:AddMessage("1 .. " .. arg1) end
			if arg2 ~= nil then ChatFrame1:AddMessage("2 .. " .. arg2) end
			if arg3 ~= nil then ChatFrame1:AddMessage("3 .. " .. arg3) end 
			if arg4 ~= nil then ChatFrame1:AddMessage("4 .. " .. arg4) end 
			if arg5 ~= nil then ChatFrame1:AddMessage("5 .. " .. arg5) end 
			if arg6 ~= nil then ChatFrame1:AddMessage("6 .. " .. arg6) end 
		end
	end

	if event == "CHAT_MSG_PARTY" or event == "CHAT_MSG_RAID" or event == "CHAT_MSG_RAID_LEADER" or event == "CHAT_MSG_RAID_WARNING" or event == "CHAT_MSG_SAY" then
		arg1_s = string.lower(arg1)
		
	--Find the start and end location of the item link
		xRR_Start_Loc,_ = string.find(arg1_s, "item:");
		_,xRR_End_Loc = string.find(arg1_s, "|h|r")
		
		if xRR_Start_Loc == nil then xRR_Start_Loc = 0 end
		if xRR_End_Loc == nil then xRR_End_Loc = 0 end
		
		
	--Get the words before and after the item link
		RR_String_minus_ILink1 = strsub(arg1,0,xRR_Start_Loc-12)
		RR_String_minus_ILink2 = strsub(arg1,xRR_End_Loc,strlen(arg1))
		
	--If they are nil set them to blank values
		if RR_String_minus_ILink1 == nil then RR_String_minus_ILink1 = "" end
		if RR_String_minus_ILink2 == nil then RR_String_minus_ILink2 = "" end

	--Put them together
		RR_String_minus_ILink = RR_String_minus_ILink1 .. RR_String_minus_ILink2
		
		
	-- use lower case characters
		RR_String_minus_ILink = string.lower(RR_String_minus_ILink)
		
		if RaidRoll_DB["debug"] == true then ChatFrame1:AddMessage(RR_String_minus_ILink) end	
		
		RR_ChatRollFound = string.find(RR_String_minus_ILink, "roll")
		if RR_ChatRollFound == nil then
			--ChatFrame1:AddMessage("Checking for german")
			--ChatFrame1:AddMessage(wurfelt)
			RR_ChatRollFound = string.find(RR_String_minus_ILink, LOCALE_RR_Roll)
		end
		
		-- Includes german searching for roll announcement
		if string.find(arg1_s, "|h|r") ~= nil and string.find(RR_String_minus_ILink, "raid roll") == nil and RR_ChatRollFound ~= nil then 
			if RaidRoll_DB["debug"] == true then ChatFrame1:AddMessage("Rolling on an item detected") end
			
		--Timestamp of when the rolling was announced
			RR_Timestamp = time()
			if RaidRoll_DB["debug"] == true then  ChatFrame1:AddMessage("Timestamp set to :" .. RR_Timestamp) end	--Debugging, displays the timestamp
			
			-- This being false tells us that we should begin decrementing the counter
			RR_Doing_a_New_Roll = false
			
			
		--Cut the itemlink out of the string
			if xRR_Start_Loc ~= nil and xRR_End_Loc ~= nil then
				xRR_ItemLink = strsub(arg1,xRR_Start_Loc-12,xRR_End_Loc)
			end
		--For debugging, show the itemlink
			if RaidRoll_DB["debug"] == true then ChatFrame1:AddMessage(xRR_ItemLink) end
			
			if rr_Item[rr_rollID] ~= "ID #"..rr_rollID or RollerName[rr_rollID][1] ~= "" then
			
				rr_rollID = rr_rollID + 1	
				
				
				if rr_CurrentRollID+1 == rr_rollID then
					rr_CurrentRollID = rr_rollID
				end
			end
			
				rr_Item[rr_rollID] = xRR_ItemLink
				rr_RollSort(rr_rollID,0,"",true)

			

			
			if RaidRoll_DB["debug"] == true then ChatFrame1:AddMessage("New item roll found, ID#" .. rr_rollID) end
		end
		
		RR_Rolling_on_item = true
		
	end


-- Roll handler
	if event == "CHAT_MSG_SYSTEM" then
		local Name,Roll,Low,High = RR_RollHandler(arg1)
		
		if Name ~= nil then 
			RR_ARollHasOccured(Name,Roll,Low,High)
		end
	end
end

function RR_ARollHasOccured(Name,Roll,Low,High)

local Roll = tonumber(Roll)
local Low = tonumber(Low)
local High = tonumber(High)

-- Standard Roll Catcher
	if RR_Rolling_on_item == true then
	-- Debugging, tells us how long after the announcement the roll was detected
		if RaidRoll_DB["debug"] == true then ChatFrame1:AddMessage("Roll detected " .. time() - RR_Timestamp .. " seconds after announcement") end
			
	-- If its less than 60 seconds after then accept the roll
		if time() < RR_Timestamp + 60 or RR_Track_Unannounced_Rolls == true then
		--This creates a new window for rolls made more than 60 seconds after the last roll if the option to track unannounced rolls is turned on
			if RR_Track_Unannounced_Rolls == true then
				if time() > RR_Timestamp + 60 then
					RR_NewRoll()
				end
			end
			
		-- This controls the showing of the window (true = show window, false = dont show window)
			if RR_Roll_Tracking_Enabled == true then
				RR_RollFrame:Show()
				RR_NAME_FRAME:Show()
			end
				
		-- Find out if the roll is a standard (1-100) roll or not
			if High == 100 and Low == 1 then
				RR_LegitRoll = true
				if RaidRoll_DB["debug"] == true then ChatFrame1:AddMessage("Standard roll detected") end
			else
				RR_LegitRoll = false
			end
			
		-- This being false tells us that we should begin decrementing the counter
			RR_Doing_a_New_Roll = false
			
		-- Create a new array for rolls if needed
			if rr_Roll[rr_rollID] == nil then rr_Roll[rr_rollID] = {} end
			
		-- If the person has not rolled yet
			if rr_Roll[rr_rollID][Name] == nil then
			-- Record their roll
				rr_Roll[rr_rollID][Name] = tonumber(Roll)
				
			-- If the list of players that rolled is empty then set it to 1, otherwise add 1 to it
				if rr_PlayersRolled[rr_rollID] == nil then 
					rr_PlayersRolled[rr_rollID] = 1
				else
					rr_PlayersRolled[rr_rollID] = rr_PlayersRolled[rr_rollID] + 1
				end
				
			-- Debugging message, tells you how many ppl have rolled unique rolls
				if RaidRoll_DB["debug"] == true then ChatFrame1:AddMessage("Total players rolled: " .. rr_PlayersRolled[rr_rollID])	end
				
			
				if rr_playername[rr_rollID] == nil then	rr_playername[rr_rollID] = {} end
				
				rr_playername[rr_rollID][rr_PlayersRolled[rr_rollID]] = Name	
				
				rr_RollSort(rr_rollID,Roll,Name,true,true,RR_LegitRoll)
				
			else
				rr_RollSort(rr_rollID,Roll,Name,true,false,RR_LegitRoll)
			end
		end
	end		

	
-- Raid Roll Catcher
	if RR_Has_Rolled == true then
	--Check if the player rolling is the user
		if Name == UnitName("player") then
			if RaidRoll_DB["debug"] == true then ChatFrame1:AddMessage("You have rolled on a raid roll") end
			
			if RR_Name_Array[Roll] ~= nil and RR_ItemLink == nil then
				SendChatMessage(">>> " .. RR_Name_Array[Roll] .. " Wins! <<<", rr_AnnounceType1)
			end
			
			if RR_Name_Array[Roll] ~= nil and RR_ItemLink ~= nil then
				SendChatMessage(">>> " .. RR_Name_Array[Roll] .. " Wins " .. RR_ItemLink .. "! <<<", rr_AnnounceType1)
			end
			
			RR_Has_Rolled  = false
		end
	end

end


-- Function donated by zanglang
-- Originally used in RollTracker Lite
-- URL: http://wow.curse.com/downloads/wow-addons/details/rolltracker.aspx
function RR_RollHandler(msg)

local Name,Roll,Low,High
	-- using RANDOM_ROLL_RESULT from GlobalStrings.lua
	-- %s rolls %d (%d-%d) to (.+) rolls (%d+) %((%d+)-(%d+)%)
	local pattern = string.gsub(RANDOM_ROLL_RESULT, "[%(%)-]", "%%%1")
	pattern = string.gsub(pattern, "%%s", "(.+)")
	pattern = string.gsub(pattern, "%%d", "%(%%d+%)")
	
	if msg ~= nil then 
		if string.find(msg, "%(") ~= nil then
			if string.find(msg, "%)") ~= nil then
				if string.find(msg, "%-") ~= nil then
					for name, roll, low, high in string.gmatch(msg, pattern) do
						Name = name;
						Roll = tonumber(roll);
						Low = tonumber(low);
						High = tonumber(high);
					end
				end
			end	
		end
	end
	
	if RaidRoll_DB["debug"] == true then 
		ChatFrame1:AddMessage("Roll Handler")	
		ChatFrame1:AddMessage(Name)		
		ChatFrame1:AddMessage(Roll)		
		ChatFrame1:AddMessage(Low)		
		ChatFrame1:AddMessage(High)		
	end
	
	return Name,Roll,Low,High
end


-- PlayerRoll = the roll performed 
-- PlayerName = the name of the player who rolled
-- rr_rollID = the id of the list
-- rr_FirstRoll = was it this persons first roll? (true / false)
-- rr_AddedPlayer = if we added a player this is true, otherwise it is false (for re-sorting)


function rr_RollSort(rr_rollID,PlayerRoll,PlayerName,rr_AddedPlayer,rr_FirstRoll,RR_LegitRoll)


--ChatFrame1:AddMessage(MaxPlayers[rr_rollID])
		

local temp

--if rr_rollID == nil then rr_rollID = rr_CurrentRollID end 

	if rr_AddedPlayer == true then
		
	-- Checks for the variables that are passed to make sure no nil values are passed
		if rr_FirstRoll ==   nil then 	rr_FirstRoll = false   end	-- Was this their first roll?
		if rr_GuildRank ==   nil then 	rr_GuildRank = ""      end	-- What was their Guild Rank?
		if rr_AddedPlayer == nil then 	rr_AddedPlayer = false end	-- Are you adding more players to the list or just re-sorting? (SET THIS TO DEFAULT FALSE)
		if RR_LegitRoll == nil then 	RR_LegitRoll = false   end	-- Is it a 1-100 roll?

		
	-- If this is the first time that it is called then set the max rollers value to zero
		if MaxPlayers[rr_rollID] == nil then MaxPlayers[rr_rollID] = 0 end
		
	-- If you are to add a player then increment the value
		if rr_AddedPlayer == true then MaxPlayers[rr_rollID] = MaxPlayers[rr_rollID] + 1 end
		
		
		
	-- If there are less than 5 rollers then set the value to 5 (to avoid bugs)
		if MaxPlayers[rr_rollID] < 5 then
			MaxPlayersValue = 5
		else
			MaxPlayersValue = MaxPlayers[rr_rollID]
		end
		
		
		
		
	-- Making the variable to an array
		if RollerName[rr_rollID] == nil then RollerName[rr_rollID] = {} end
		if RollerRoll[rr_rollID] == nil then RollerRoll[rr_rollID] = {} end
		if RollerFirst[rr_rollID] == nil then RollerFirst[rr_rollID] = {} end
		if RollerRank[rr_rollID] == nil then RollerRank[rr_rollID] = {} end
		if RollerRankIndex[rr_rollID] == nil then RollerRankIndex[rr_rollID] = {} end
		if HasRolled[rr_rollID] == nil then HasRolled[rr_rollID] = {} end		
		if Roll_Number[rr_rollID] == nil then Roll_Number[rr_rollID] = {} end		
		if RaidRoll_LegitRoll[rr_rollID] == nil then RaidRoll_LegitRoll[rr_rollID] = {} end	

		
		
		
		if HasRolled[rr_rollID][PlayerName] == nil then
			HasRolled[rr_rollID][PlayerName] = 1
		else
			HasRolled[rr_rollID][PlayerName] = HasRolled[rr_rollID][PlayerName] + 1
		end
		
		Roll_Number[rr_rollID][MaxPlayersValue] = HasRolled[rr_rollID][PlayerName]
		
	-- Filling in the blank values with dummies
		for i=1,MaxPlayersValue-1 do
			if RollerName[rr_rollID][i]  == nil then RollerName[rr_rollID][i]  = "" end
			if RollerRoll[rr_rollID][i]  == nil then RollerRoll[rr_rollID][i]  = 0  end
			if RollerFirst[rr_rollID][i] == nil then RollerFirst[rr_rollID][i] = false end
			if RollerRank[rr_rollID][i]  == nil then RollerRank[rr_rollID][i]  = "" end
			if RollerRankIndex[rr_rollID][i]  == nil then RollerRankIndex[rr_rollID][i]  = 11 end
			if RaidRoll_LegitRoll[rr_rollID][i]  == nil then RaidRoll_LegitRoll[rr_rollID][i]  = false end
		end
		
	-- Setting the players name, roll, guild rank and roll status to the current max players value
		if rr_AddedPlayer == true then
			RollerName[rr_rollID][MaxPlayersValue] = PlayerName
			RollerRoll[rr_rollID][MaxPlayersValue] = tonumber(PlayerRoll)
			
			RollerFirst[rr_rollID][MaxPlayersValue] = rr_FirstRoll
			
		-- Default rank and rank id values (will be overwritten if the person is in the guild
			RollerRank[rr_rollID][MaxPlayersValue] = ""
			RollerRankIndex[rr_rollID][MaxPlayersValue] = 10
			
			RaidRoll_LegitRoll[rr_rollID][MaxPlayersValue] = RR_LegitRoll
			
		-- Get how many guild members are online
			numOnline = GetNumGuildMembers()
			
		-- scan the guild info for the person 
			for i=1,numOnline do
				name, rank, rankIndex = GetGuildRosterInfo(i)
			
			-- If a match is found set the rank and rankindex 
				if PlayerName == name then
					RollerRank[rr_rollID][MaxPlayersValue] = rank
					RollerRankIndex[rr_rollID][MaxPlayersValue] = rankIndex
				end
			end		
			
		-- Debugging, lists the name, guild rank, and guild rank id of the player (Rank ID starts at 0)
			if RaidRoll_DB["debug"] == true then ChatFrame1:AddMessage(RollerName[rr_rollID][MaxPlayersValue] .. " " .. RollerRank[rr_rollID][MaxPlayersValue] .. " " .. RollerRankIndex[rr_rollID][MaxPlayersValue]) end
			
		end	
		
	--Debugging values 
		--[[
		RollerRoll[rr_rollID][1] = 2
		RollerRoll[rr_rollID][2] = 4
		RollerRoll[rr_rollID][3] = 5
		RollerRoll[rr_rollID][4] = 1
		RollerRoll[rr_rollID][5] = 9
		]]
		
	end
		
	
	if MaxPlayersValue ~= nil then
		
		for i=1,MaxPlayersValue do
			--ChatFrame1:AddMessage(i)	-- Debugging, shows the ''i'' value
			for j=1,MaxPlayersValue-1 do
				--ChatFrame1:AddMessage(j) 	-- Debugging, shows the ''j'' value
				if RollerRoll[rr_rollID][j+1] ~= nil then
					if RollerRoll[rr_rollID][j+1] > RollerRoll[rr_rollID][j] then
						RaidRoll_Flip(rr_rollID,j)
					end
				end
			end
		end
		
		if RR_RankPriority == true then
			for i=1,MaxPlayersValue do
				--ChatFrame1:AddMessage(i)	-- Debugging, shows the ''i'' value
				for j=1,MaxPlayersValue-1 do
					--ChatFrame1:AddMessage(j) 	-- Debugging, shows the ''j'' value
					--ChatFrame1:AddMessage("i=" .. i .. " j=" .. " " .. j .. RollerRankIndex[rr_rollID][j+1] .. "/" .. RollerRankIndex[rr_rollID][j])
					if RollerRankIndex[rr_rollID][j+1] ~= nil then
						if RaidRoll_DB["Rank Priority"][RollerRankIndex[rr_rollID][j+1]+1] > RaidRoll_DB["Rank Priority"][RollerRankIndex[rr_rollID][j]+1] then
							RaidRoll_Flip(rr_rollID,j)
						end
					end
				end
			end
		end
		
		
		if RR_AllowExtraRolls == false then
			for i=1,MaxPlayersValue do
				--ChatFrame1:AddMessage(i)	-- Debugging, shows the ''i'' value
				for j=1,MaxPlayersValue-1 do
					--ChatFrame1:AddMessage(j) 	-- Debugging, shows the ''j'' value
					--ChatFrame1:AddMessage("i=" .. i .. " j=" .. j .. " " .. RollerRankIndex[rr_rollID][j+1] .. "/" .. RollerRankIndex[rr_rollID][j])
					if RollerFirst[rr_rollID][j+1] ~= nil then
						if RollerFirst[rr_rollID][j+1] == true and RollerFirst[rr_rollID][j] == false then
							RaidRoll_Flip(rr_rollID,j)
						end
					end
				end
			end
		end
		
		
		
--Debugging, lists all the raid rolls
		--[[ChatFrame1:AddMessage("Listing Results")
		for i=1,41 do
			ChatFrame1:AddMessage(RollerName[rr_rollID][i])
			ChatFrame1:AddMessage(RollerRoll[rr_rollID][i])
		end
		]]
		
		if rr_CurrentRollID == rr_rollID then
				RR_Display(rr_rollID)
		end
		
	end
	
end

function RaidRoll_Flip(rr_rollID,j)

	temp = RollerRoll[rr_rollID][j+1]
	RollerRoll[rr_rollID][j+1] = RollerRoll[rr_rollID][j]
	RollerRoll[rr_rollID][j] = temp
	
	temp = RollerName[rr_rollID][j+1]
	RollerName[rr_rollID][j+1] = RollerName[rr_rollID][j]
	RollerName[rr_rollID][j] = temp
	
	temp = RollerRank[rr_rollID][j+1]
	RollerRank[rr_rollID][j+1] = RollerRank[rr_rollID][j]
	RollerRank[rr_rollID][j] = temp
	
	temp = RollerRankIndex[rr_rollID][j+1]
	RollerRankIndex[rr_rollID][j+1] = RollerRankIndex[rr_rollID][j]
	RollerRankIndex[rr_rollID][j] = temp
	
	temp = RollerFirst[rr_rollID][j+1]
	RollerFirst[rr_rollID][j+1] = RollerFirst[rr_rollID][j]
	RollerFirst[rr_rollID][j] = temp
	
	temp = Roll_Number[rr_rollID][j+1]
	Roll_Number[rr_rollID][j+1] = Roll_Number[rr_rollID][j]
	Roll_Number[rr_rollID][j] = temp
	
	temp = RaidRoll_LegitRoll[rr_rollID][j+1]
	RaidRoll_LegitRoll[rr_rollID][j+1] = RaidRoll_LegitRoll[rr_rollID][j]
	RaidRoll_LegitRoll[rr_rollID][j] = temp
	
end


function RR_Update_Name_Frame(RR_DisplayID)

l_RR_DisplayID = RR_DisplayID

	-- If you clicked "new roll" then dont  decrement the timer (unless there was a roll performed)
	if RR_Doing_a_New_Roll == true then RR_Timestamp = time() end

	if time() < RR_Timestamp + 60 and rr_rollID == rr_CurrentRollID then
		getglobal("RR_Itemname"):SetText("(" .. 60 - time() + RR_Timestamp .. ") " .. rr_Item[l_RR_DisplayID])
	else
		getglobal("RR_Itemname"):SetText(rr_Item[l_RR_DisplayID])
	end
	
	
	--RR_width = getglobal("RR_Itemname"):GetWidth();

	RR_NAME_FRAME:SetWidth(getglobal("RR_Itemname"):GetWidth() + 20)
	
	--if RR_width + 45 > 185 then
	--	RR_RollFrame:SetWidth(RR_width+45);
	--else
	--	RR_RollFrame:SetWidth(185);
	--end
	

	
	if not _RR then 
		UIParent:HookScript("OnUpdate",function() if _RR>0 and GetTime()>=_RR then _RR=0 RR_Update_Name_Frame(l_RR_DisplayID); end end)
	end 
	_RR=GetTime()
	

	
end

function RR_Display(RR_DisplayID)

RR_HasDisplayedAlready = true

l_RR_DisplayID = RR_DisplayID

	if RollerGroup[l_RR_DisplayID] == nil then RollerGroup[l_RR_DisplayID] = {} end

---If the current roll is the latest rol it shows a 60 second countdown
	if time() < RR_Timestamp + 60 and rr_rollID == rr_CurrentRollID then
		getglobal("RR_Itemname"):SetText("(" .. 60 - time() + RR_Timestamp .. ") " .. rr_Item[l_RR_DisplayID])
		RR_Update_Name_Frame(l_RR_DisplayID)
	else
		getglobal("RR_Itemname"):SetText(rr_Item[l_RR_DisplayID])
	end
	
	if RollerFirst[RR_DisplayID] ~= nil and RollerFirst[RR_DisplayID][1] ~= nil then
		for i=1,5 do
			
			getglobal("RR_RollerPos"..i):SetText(i + RR_ScrollOffset .. ":")
			
			if RollerFirst[RR_DisplayID][i+RR_ScrollOffset] == false then
				color = "|cFF11aacc"
			else
				color = "|cFFFF0000|r"
			end
			
		-- Checks to see if the roll should be shown
		-- RR_Accept_All_Rolls
		-- RaidRoll_LegitRoll
		
			if (RaidRoll_LegitRoll[RR_DisplayID][i+RR_ScrollOffset] == false and RR_Accept_All_Rolls == false) or (RR_AllowExtraRolls == false and RollerFirst[RR_DisplayID][i+RR_ScrollOffset] == false) then
				getglobal("RR_Roller"..i):SetText("")
				getglobal("RR_Rolled"..i):SetText("")
				getglobal("Raid_Roll_Rank_String"..i):SetText("")
				getglobal("RR_Group"..i):SetText("")
			else
				if RR_NameMark[strlower(RollerName[RR_DisplayID][i+RR_ScrollOffset])] == nil then	RR_NameMark[strlower(RollerName[RR_DisplayID][i+RR_ScrollOffset])] = false end
				
				if RR_NameMark[strlower(RollerName[RR_DisplayID][i+RR_ScrollOffset])] == true then 
					mark = "! " 
				else
					mark = "" 
				end
				
				
				getglobal("RR_Roller"..i):SetText(color .. mark .. RollerName[RR_DisplayID][i+RR_ScrollOffset])
				
				if RollerRoll[RR_DisplayID][i+RR_ScrollOffset] == 0 then
					getglobal("RR_Rolled"..i):SetText("")
				else
					if RaidRoll_LegitRoll[RR_DisplayID][i+RR_ScrollOffset] == true then
						ExtraChar = ""
					else
						ExtraChar = "*"
					end
					
					if RollerFirst[RR_DisplayID][i+RR_ScrollOffset] == true then
						getglobal("RR_Rolled"..i):SetText(color .. RollerRoll[RR_DisplayID][i+RR_ScrollOffset] .. ExtraChar)
					else
						getglobal("RR_Rolled"..i):SetText(color .. "(" .. Roll_Number[RR_DisplayID][i+RR_ScrollOffset] .. ") " .. RollerRoll[RR_DisplayID][i+RR_ScrollOffset] .. ExtraChar)
					end
				end
				
				
				if RollerRankIndex[RR_DisplayID][i+RR_ScrollOffset] == 99 then
					getglobal("Raid_Roll_Rank_String"..i):SetText("")
				else
					getglobal("Raid_Roll_Rank_String"..i):SetText(color .. "(" .. RollerRankIndex[RR_DisplayID][i+RR_ScrollOffset] .. ") " .. RollerRank[RR_DisplayID][i+RR_ScrollOffset])
				end
				
				for j = 1,40 do
					local name, rank, subgroup, level, class, fileName, zone, online, isDead, role, isML = GetRaidRosterInfo(j);
					
					--ChatFrame1:AddMessage(j .. name .. subgroup)
					
					if name == RollerName[RR_DisplayID][i+RR_ScrollOffset] then
						--ChatFrame1:AddMessage(i .. " " .. RollerName[RR_DisplayID][i+RR_ScrollOffset] .. " - " .. name)
						RollerGroup[RR_DisplayID][i+RR_ScrollOffset] = subgroup
					end
				end
				
				if RollerGroup[RR_DisplayID][i+RR_ScrollOffset] == nil then RollerGroup[RR_DisplayID][i+RR_ScrollOffset] = "" end
				getglobal("RR_Group"..i):SetText(color .. RollerGroup[RR_DisplayID][i+RR_ScrollOffset])
			end
		end
	end

	-- This controls the showing of the window (true = show window, false = dont show window)
		if RR_Roll_Tracking_Enabled == true then
			RR_RollFrame:Show()
			RR_NAME_FRAME:Show()
		end
	
	if rr_rollID ~= 0 then
		if rr_CurrentRollID < rr_rollID then
			RR_Next:Enable()
		else
			RR_Next:Disable()
		end
		
		if rr_CurrentRollID > 0 then
			RR_Last:Enable()
		else
			RR_Last:Disable()
		end
	else
		RR_Last:Disable()
		RR_Next:Disable()
	end
	
end


function RR_Command(cmd)
--Stuff that happens when you press /mm <command>

RR_ItemLink = nil --clearing the variable

cmd_n = tonumber(cmd)
cmd_s = string.lower(cmd)

	if cmd_s == "debug" then
		if RaidRoll_DB["debug"] == nil then
			RaidRoll_DB["debug"] = true
		elseif RaidRoll_DB["debug"] == false then
			RaidRoll_DB["debug"] = true
		elseif RaidRoll_DB["debug"] == true then
			RaidRoll_DB["debug"] = false
		end
		
		if RaidRoll_DB["debug"] == true then
			ChatFrame1:AddMessage("Raid Roll - Debug Mode Enabled")
		end
		
		if RaidRoll_DB["debug"] == false then
			ChatFrame1:AddMessage("Raid Roll - Debug Mode Disabled")
		end
	end
	
	if cmd_s == "help" then
		for i=1,13 do
			ChatFrame1:AddMessage(getglobal("LOCALE_RR_HELP" .. i))
		end
	end

-- reset the position of the rolling frame
	if cmd_s == "reset" or cmd_s == "resetpos" then
		getglobal("RR_RollFrame"):ClearAllPoints(); 
		getglobal("RR_RollFrame"):SetPoint("CENTER", UIParent, "CENTER", 0, 0)
		RR_Display(rr_CurrentRollID)
	end


	if cmd_s == "show" then
		RR_RollFrame:Show()
		RR_NAME_FRAME:Show()
	end
	
	if cmd_s == "toggle" then
		if RR_RollFrame:IsShown() then
			RR_RollFrame:Hide()
			RR_NAME_FRAME:Hide()
		else
			RR_RollFrame:Show()
			RR_NAME_FRAME:Show()
		end
	end
	
	if cmd_s == "test" then
		 RR_Test()
	end	
	
	
	if cmd_s == "unan" or cmd_s == "unannounced" then
		if RR_Track_Unannounced_Rolls == true then
			RR_Track_Unannounced_Rolls =  false
			ChatFrame1:AddMessage("Raid Roll: Auto-Tracking Rolls Disabled")
			RaidRoll_Catch_All:SetChecked(false);
		else
			RR_Track_Unannounced_Rolls =  true
			ChatFrame1:AddMessage("Raid Roll: Auto-Tracking Rolls Enabled")
			RaidRoll_Catch_All:SetChecked(true);
		end
	end	

-- This controls the showing of the window (true = show window, false = dont show window)
	if cmd_s == "enable" then
		RR_Roll_Tracking_Enabled = true
		ChatFrame1:AddMessage("Raid Roll: Raid Roll Tracking enabled. Type ''/rr disable'' to disable tracking")
	end	
	
	if cmd_s == "disable" then
		RR_Roll_Tracking_Enabled = false
		ChatFrame1:AddMessage("Raid Roll: Raid Roll Tracking disabled. Type ''/rr enable'' to enable tracking")
	end	
	
	
	if cmd_s == "all" then
		if RR_Accept_All_Rolls == true then
			RR_Accept_All_Rolls =  false
			ChatFrame1:AddMessage("Raid Roll: Only 1-100 rolls accepted")
			RaidRoll_Allow_All:SetChecked(false);
		else
			RR_Accept_All_Rolls =  true
			ChatFrame1:AddMessage("Raid Roll: All rolls accepted")
			RaidRoll_Allow_All:SetChecked(true);
		end
		
	end
	
	
	
	
	
	
	
	local cmd1, cmd2, cmd3 = strsplit(" ", cmd_s, 3)
	
	if cmd1 == "mark" then
		if cmd2 ~= nil and cmd2 ~= "!reset" then
			if tonumber(cmd2) == nil then
				name = cmd2
				RR_NameMark[name] = true
			else
				name = strlower(RollerName[rr_CurrentRollID][tonumber(cmd2)])
				RR_NameMark[name] = true
			end
			
			ChatFrame1:AddMessage(name .. " " .. LOCALE_RR_added_to_marking_list)
		end
		
	end
	
	if cmd1 == "unmark" then
		if cmd2 ~= nil and cmd2 ~= "!reset" then
			if tonumber(cmd2) == nil then
				name = cmd2
				RR_NameMark[name] = false
			else
				name = strlower(RollerName[rr_CurrentRollID][tonumber(cmd2)])
				RR_NameMark[name] = false
			end
			
			ChatFrame1:AddMessage(name .. " " .. LOCALE_RR_removed_from_marking_list)
		end
	end
	
	if cmd1 == "mark" and cmd2 == "!reset" then
		RR_NameMark = {}
		ChatFrame1:AddMessage(LOCALE_RR_Marking_list_cleared)
	end
	
	if RR_RollFrame:IsShown() then
		RR_Display(rr_CurrentRollID)
	end	
	
	
	
	
	
	
	
	
	-- GetNumRaidMembers() == 0 then alone / in party
	
if RaidRoll_DB["debug"] == true then if cmd == "" then ChatFrame1:AddMessage("Standard Raid Roll Detected") end end

--Do a standard Raid roll
	if cmd == "" then 
		if GetNumRaidMembers() ~= 0 then 
			if RaidRoll_DB["debug"] == true then  ChatFrame1:AddMessage("Raid Group detected. Doing a raid roll") end
			RR_DoARaidRoll()
		else
			if RaidRoll_DB["debug"] == true then  ChatFrame1:AddMessage("You are not in a raid group. Doing a party roll") end
			RR_DoAPartyRoll()
		end
	end
	
	
	

--Find the start and end location of the item link
	RR_Start_Loc,_ = string.find(cmd, "item:");
	_,RR_End_Loc = string.find(cmd, "|h|r")
	
--Cut the itemlink out of the string
	if RR_Start_Loc ~= nil and RR_End_Loc ~= nil then
		RR_ItemLink = strsub(cmd,RR_Start_Loc-12,RR_End_Loc)
	end
--For debugging, show the itemlink
	if RaidRoll_DB["debug"] == true then ChatFrame1:AddMessage(RR_ItemLink) end
	
--Cut up the command to see if it was a reroll or not
	RR_Reroll = strsub(cmd_s,1,3)
	RR_Reroll_Long = strsub(cmd_s,1,6)
	
--for debugging, show the results of the split up string
	if RaidRoll_DB["debug"] == true then ChatFrame1:AddMessage(RR_Reroll) end
	if RaidRoll_DB["debug"] == true then ChatFrame1:AddMessage(RR_Reroll_Long) end
	
--Do a  repeat Raid roll
	if RR_Reroll == "re " or RR_Reroll_Long == "reroll" or cmd1 == "re" then
		if RR_ItemLink ~= nil then 
			if GetNumRaidMembers() ~= 0 then 
				if RaidRoll_DB["debug"] == true then  ChatFrame1:AddMessage("Raid Group detected. Doing a raid roll") end
				RR_DoARaidRoll(RR_ItemLink,"ReRoll")
			else
				if RaidRoll_DB["debug"] == true then  ChatFrame1:AddMessage("You are not in a raid group. Doing a party roll") end
				RR_DoAPartyRoll(RR_ItemLink,"ReRoll")
			end
		else
			if GetNumRaidMembers() ~= 0 then 
				if RaidRoll_DB["debug"] == true then  ChatFrame1:AddMessage("Raid Group detected. Doing a raid roll") end
				RR_DoARaidRoll(nil,"ReRoll")
			else
				if RaidRoll_DB["debug"] == true then  ChatFrame1:AddMessage("You are not in a raid group. Doing a party roll") end
				RR_DoAPartyRoll(nil,"ReRoll")
			end
		end
	else
	--Do a  Raid roll and show the item being rolled for
		if RR_ItemLink ~= nil then 
			if GetNumRaidMembers() ~= 0 then 
				if RaidRoll_DB["debug"] == true then  ChatFrame1:AddMessage("Raid Group detected. Doing a raid roll") end
				RR_DoARaidRoll(RR_ItemLink)
			else
				if RaidRoll_DB["debug"] == true then  ChatFrame1:AddMessage("You are not in a raid group. Doing a party roll") end
				RR_DoAPartyRoll(RR_ItemLink)
			end
		end
	end
	
	
end

function RR_DoARaidRoll(ItemLink, Type)

-- Set the number to the amout of people in the raid
	RR_num = GetNumRaidMembers()
	local num = RR_num

-- Clear the list of people in the raid
	if RR_Name_Array == nil then 
		RR_Name_Array = {}
	end
	
-- Setup announce types (if raid leader its raid warning, otherwise its raid chat)
	rr_AnnounceType1 = "RAID"
	if IsRaidLeader() ~= nil or IsRaidOfficer() ~= nil then
		rr_AnnounceType2 = "RAID_WARNING"
	else
		rr_AnnounceType2 = "RAID"
	end
	
-- If the array is empty then we are not doing a reroll
	if RR_Name_Array[1] == nil then
		if RaidRoll_DB["debug"] == true then  ChatFrame1:AddMessage("Name array empty, we are not rerolling") end
		Type = nil	
	end

	
-- Output the list of people to raid chat if its not a reroll
	if Type ~= "ReRoll" then
		
	-- Check if there is an item being rolled on
		if ItemLink == nil then
			SendChatMessage("<<Raid Rolling>> (ID - Name)" , rr_AnnounceType2)
		else
			SendChatMessage("<<Raid Rolling for: " .. ItemLink .. " >> (ID - Name)" , rr_AnnounceType2)
		end
		
	-- Add the members of the raid to the name array
		for i=1,GetNumRaidMembers() do
			RR_Name_Array[i] = GetRaidRosterInfo(i)
		end
		
		if num < 21 then 
			num = num + 1
			for i=1,num/2 do
				i_mod = 2 * i
				--ChatFrame1:AddMessage(i_mod .. num)
				if GetRaidRosterInfo(i_mod) ~= nil and i_mod <= num-1 then 
					SendChatMessage("#".. i_mod-1 .." - " .. GetRaidRosterInfo(i_mod-1) .. "" .. "    #" .. i_mod .." - " .. GetRaidRosterInfo(i_mod), rr_AnnounceType1)
				else
					SendChatMessage("#".. i_mod-1 .." - " .. GetRaidRosterInfo(i_mod-1), rr_AnnounceType1)
				end
				--ChatFrame1:AddMessage("#".. i .." - " .. GetRaidRosterInfo(i))
				--ChatFrame1:AddMessage(num)				
			end
		else
			num = num + 2
			for i=1,num/3 do
				i_mod = 3 * i
				--ChatFrame1:AddMessage(i_mod .. num)
				if GetRaidRosterInfo(i_mod) ~= nil and i_mod <= num-2 then 
					SendChatMessage("#".. i_mod-2 .." - " .. GetRaidRosterInfo(i_mod-2) .. "    #" .. i_mod-1 .." - " .. GetRaidRosterInfo(i_mod-1) .. "    #" .. i_mod .." - " .. GetRaidRosterInfo(i_mod), rr_AnnounceType1)
				elseif GetRaidRosterInfo(i_mod-1) ~= nil and  i_mod <= num-1 then
					SendChatMessage("#".. i_mod-2 .." - " .. GetRaidRosterInfo(i_mod-2) .. "" .. "    #" .. i_mod-1 .." - " .. GetRaidRosterInfo(i_mod-1), rr_AnnounceType1)
				else
					SendChatMessage("#".. i_mod-2 .." - " .. GetRaidRosterInfo(i_mod-2), rr_AnnounceType1)
				end
				--ChatFrame1:AddMessage("#".. i .." - " .. GetRaidRosterInfo(i))
				--ChatFrame1:AddMessage(num)				
			end
		end
	else
	-- Check if there is an item being rolled on
		if ItemLink == nil then
			SendChatMessage("<<Re-Rolling>>" , rr_AnnounceType2)
		else
			SendChatMessage("<<Re-Rolling for: " .. ItemLink .. " >>" , rr_AnnounceType2)
		end
	end
	
-- After 2 seconds do a roll
	if not _Y then 
		UIParent:HookScript("OnUpdate",function() if _Y>0 and GetTime()>=_Y then _Y=0 RR_Roll(); end end)
	end 
	_Y=GetTime()+2
	
end


function RR_DoAPartyRoll(ItemLink, Type)

-- Set the number to the amout of people in the party (it ranges from 0-4)
	RR_num = GetNumPartyMembers() + 1
	local num = RR_num

-- Clear the list of people in the raid
	if RR_Name_Array == nil then 
		RR_Name_Array = {}
	end
	
-- Setup announce types (Party and raid warning if in a party, say if alone)
	if GetNumPartyMembers() > 0 then
		rr_AnnounceType1 = "PARTY"
		rr_AnnounceType2 = "RAID_WARNING"
	else
		rr_AnnounceType1 = "SAY"
		rr_AnnounceType2 = "SAY"
	end
	
-- If the array is empty then we are not doing a reroll
	if RR_Name_Array[1] == nil then
		if RaidRoll_DB["debug"] == true then  ChatFrame1:AddMessage("Name array empty, we are not rerolling") end
		Type = nil	
	end
	
-- Output the list of people to raid chat if its not a reroll
	if Type ~= "ReRoll" then
	
	-- Check if there is an item being rolled on
		if ItemLink == nil then
			SendChatMessage("<<Raid Rolling>> (ID - Name)" , rr_AnnounceType2)
		else
			SendChatMessage("<<Raid Rolling for: " .. ItemLink .. " >> (ID - Name)" , rr_AnnounceType2)
		end
	
	-- Add the members of the raid to the name array
		for i=1,RR_num do
			if i == 1 then
				RR_Name_Array[i] = UnitName("player")
			else
				RR_Name_Array[i] = UnitName("party" .. i-1)
			end
		end
		
		num = num + 1
		for i=1,num/2 do
			i_mod = 2 * i
			--ChatFrame1:AddMessage(i_mod .. num)
			if RR_Name_Array[i_mod] ~= nil and i_mod <= num-1 then 
				SendChatMessage("#".. i_mod-1 .." - " .. RR_Name_Array[i_mod-1] .. "" .. "    #" .. i_mod .." - " .. RR_Name_Array[i_mod], rr_AnnounceType1)
			else
				SendChatMessage("#".. i_mod-1 .." - " .. RR_Name_Array[i_mod-1], rr_AnnounceType1)
			end		
		end
	else
	-- Check if there is an item being rolled on
		if ItemLink == nil then
			SendChatMessage("<<Re-Rolling>>" , rr_AnnounceType2)
		else
			SendChatMessage("<<Re-Rolling for: " .. ItemLink .. " >>" , rr_AnnounceType2)
		end
	end
	
-- After 2 seconds do a roll
	if not _Y then 
		UIParent:HookScript("OnUpdate",function() if _Y>0 and GetTime()>=_Y then _Y=0 RR_Roll(); end end)
	end 
	_Y=GetTime()+2
	
end

function RR_Roll()

RandomRoll(1,RR_num);

RR_Has_Rolled = true

end


function RR_CloseWindow()
	RR_RollFrame:Hide()
	RR_NAME_FRAME:Hide()
end

function RR_PrevRoll()

	RR_ScrollOffset = 0

	if rr_CurrentRollID > 0 then
		rr_CurrentRollID = rr_CurrentRollID - 1
		RR_Display(rr_CurrentRollID)
	end
	
	if rr_CurrentRollID == 0 then 
		RR_Last:Disable()
		RR_Next:Enable()
	else
		RR_Last:Enable()
		RR_Next:Enable()
	end
	
	rr_RollSort(rr_CurrentRollID)
	RR_Display(rr_CurrentRollID)
end

function RR_NewRoll()

	RR_ScrollOffset = 0
	
	RR_Timestamp = time()
	--ChatFrame1:AddMessage("Timestamp set to :" .. RR_Timestamp)	--Debugging, displays the timestamp
	
	RR_Doing_a_New_Roll = true

	if RollerName[rr_rollID][1] ~= "" or rr_Item[rr_rollID] ~= "ID #"..rr_rollID then
		rr_rollID = rr_rollID + 1		
		
		rr_Item[rr_rollID] = "ID #"..rr_rollID
		
		
		if rr_CurrentRollID+1 == rr_rollID then
			rr_CurrentRollID = rr_rollID
			RR_Last:Enable()
		end
		
		rr_RollSort(rr_rollID,0,"",true)
	end
	
	rr_RollSort(rr_CurrentRollID)
	RR_Display(rr_CurrentRollID)
end

function RR_NextRoll()

	RR_ScrollOffset = 0
	
	if rr_CurrentRollID < rr_rollID then
		rr_CurrentRollID = rr_CurrentRollID + 1
		RR_Display(rr_CurrentRollID)
	end
	
	if rr_CurrentRollID == rr_rollID then 
		RR_Next:Disable()
		RR_Last:Enable()
	else
		RR_Next:Enable()
		RR_Last:Enable()
	end	
	
	rr_RollSort(rr_CurrentRollID)
	RR_Display(rr_CurrentRollID)
end

function RaidRoll_CheckButton_Update()

--RaidRoll_Allow_All:SetChecked(true);
	if RaidRoll_Catch_All:GetChecked()  then
		RR_Track_Unannounced_Rolls =  true
		RaidRoll_Catch_All:SetChecked(true)
		RR_RollCheckBox_Unannounced_panel:SetChecked(true)
		--ChatFrame1:AddMessage("Raid Roll: Auto-Tracking Rolls Enabled")
	else
		RR_Track_Unannounced_Rolls =  false
		RaidRoll_Catch_All:SetChecked(false)
		RR_RollCheckBox_Unannounced_panel:SetChecked(false)
		--ChatFrame1:AddMessage("Raid Roll: Auto-Tracking Rolls Disabled")
	end

	if RaidRoll_Allow_All:GetChecked()  then
		RR_Accept_All_Rolls =  true
		RaidRoll_Allow_All:SetChecked(true)
		RR_RollCheckBox_AllRolls_panel:SetChecked(true)
		--ChatFrame1:AddMessage("Raid Roll: All rolls accepted")
	else
		RR_Accept_All_Rolls =  false
		RaidRoll_Allow_All:SetChecked(false)
		RR_RollCheckBox_AllRolls_panel:SetChecked(false)
		--ChatFrame1:AddMessage("Raid Roll: Only 1-100 rolls accepted")
	end
	
	if RR_RollCheckBox_ExtraRolls:GetChecked()  then
		RR_AllowExtraRolls =  true
		RR_RollCheckBox_ExtraRolls:SetChecked(true)
		RR_RollCheckBox_ExtraRolls_panel:SetChecked(true)
		--ChatFrame1:AddMessage("Raid Roll: All rolls accepted")
	else
		RR_AllowExtraRolls =  false
		RR_RollCheckBox_ExtraRolls:SetChecked(false)
		RR_RollCheckBox_ExtraRolls_panel:SetChecked(false)
		--ChatFrame1:AddMessage("Raid Roll: Only 1-100 rolls accepted")
	end

--[[
	if RR_RollCheckBox_ShowRanks:GetChecked()  then
		RR_Show_Ranks =  true
		RR_RollCheckBox_ShowRanks:SetChecked(true)
		RR_RollCheckBox_ShowRanks_panel:SetChecked(true)
		for i=1,6 do
			getglobal("Raid_Roll_Rank_String"..i-1):Show()
		end
		RR_RollFrame:SetWidth(265+RR_ExtraWidth)
		getglobal("RR_Rolled"):ClearAllPoints()
		getglobal("RR_Rolled"):SetPoint("TOPLEFT", getglobal("RR_RollFrame"), "TOPLEFT",170+RR_ExtraWidth,-30)
		
		getglobal("RR_Group0"):ClearAllPoints()
		getglobal("RR_Group0"):SetPoint("TOPLEFT", getglobal("RR_RollFrame"), "TOPLEFT",220+RR_ExtraWidth,-30)
	else
		RR_Show_Ranks =  false
		RR_RollCheckBox_ShowRanks:SetChecked(false)
		RR_RollCheckBox_ShowRanks_panel:SetChecked(false)
		for i=1,6 do
			getglobal("Raid_Roll_Rank_String"..i-1):Hide()
		end
		RR_RollFrame:SetWidth(215+RR_ExtraWidth)
		getglobal("RR_Rolled"):ClearAllPoints()
		getglobal("RR_Rolled"):SetPoint("TOPLEFT", getglobal("RR_RollFrame"), "TOPLEFT",120+RR_ExtraWidth,-30)
		
		getglobal("RR_Group0"):ClearAllPoints()
		getglobal("RR_Group0"):SetPoint("TOPLEFT", getglobal("RR_RollFrame"), "TOPLEFT",170+RR_ExtraWidth,-30)
		
	end
]]
	
	
	if RR_RollCheckBox_RankPrio_panel:GetChecked()  then
		RR_RankPriority =  true
		--RR_RollCheckBox_RankPrio:SetChecked(true)
		RR_RollCheckBox_RankPrio_panel:SetChecked(true)
		--ChatFrame1:AddMessage("Raid Roll: All rolls accepted")
	else
		RR_RankPriority =  false
		--RR_RollCheckBox_RankPrio:SetChecked(false)
		RR_RollCheckBox_RankPrio_panel:SetChecked(false)
		--ChatFrame1:AddMessage("Raid Roll: Only 1-100 rolls accepted")
	end
	
	rr_RollSort(rr_CurrentRollID)
	
	if RR_HasDisplayedAlready ~= nil then
		RR_Display(rr_CurrentRollID)
	end
	
	for i=1,5 do
		getglobal("Raid_Roll_Rank_String"..i):SetWidth(65+RR_ExtraWidth); 
	end
	
	RaidRoll_CheckButton_Update_Panel()
end


function Set_RaidRoll_ExtraWidth(width)

 RR_ExtraWidth = width
 RaidRoll_CheckButton_Update()

end


function RR_SetupVariables()

	if RaidRoll_DB == nil then RaidRoll_DB = {} end

-- and arg1 == "RaidRoll"
	
	
	RR_SetupNameFrame()
	RR_ExtraFrame_Options()
	Setup_RR_Panel()
	
	
	if RaidRoll_DB["debug"] == true then RR_SetupLootFrame() end

-- Catch unannounced rolls
	if RR_Track_Unannounced_Rolls == nil or RR_Track_Unannounced_Rolls == false then
		RR_Track_Unannounced_Rolls = false	--Set true if unannounced rolls are tracked
		RaidRoll_Catch_All:SetChecked(false)
		RR_RollCheckBox_Unannounced_panel:SetChecked(false)
	else
		RaidRoll_Catch_All:SetChecked(true)
		RR_RollCheckBox_Unannounced_panel:SetChecked(true)
	end
	
-- Allow all rolls (e.g. 1-50)
	if RR_Accept_All_Rolls == nil or RR_Accept_All_Rolls == false then
		RR_Accept_All_Rolls = false	--Set true if all rolls are counted (False = only 1-100 rolls are counted)
		RaidRoll_Allow_All:SetChecked(false)
		RR_RollCheckBox_AllRolls_panel:SetChecked(false)
	else
		RaidRoll_Allow_All:SetChecked(true)
		RR_RollCheckBox_AllRolls_panel:SetChecked(true)
	end

-- Allow Extra Rolls
	if RR_AllowExtraRolls == nil or RR_AllowExtraRolls == false then
		RR_AllowExtraRolls = false	--
		RR_RollCheckBox_ExtraRolls:SetChecked(false)
		RR_RollCheckBox_ExtraRolls_panel:SetChecked(false)
	else
		RR_RollCheckBox_ExtraRolls:SetChecked(true)
		RR_RollCheckBox_ExtraRolls_panel:SetChecked(true)
	end
	
-- Show Rank beside names
	if RR_Show_Ranks == nil or RR_Show_Ranks == false then
		RR_Show_Ranks = false	--
		--RR_RollCheckBox_ShowRanks:SetChecked(false)
		RR_RollCheckBox_ShowRanks_panel:SetChecked(false)
	else
		--RR_RollCheckBox_ShowRanks:SetChecked(true)
		RR_RollCheckBox_ShowRanks_panel:SetChecked(true)
	end
	
-- Give higher ranks higher priority
	if RR_RankPriority == nil or RR_RankPriority == false then
		RR_RankPriority = false	--
		--RR_RollCheckBox_RankPrio:SetChecked(false)
		RR_RollCheckBox_RankPrio_panel:SetChecked(false)
	else
		--RR_RollCheckBox_RankPrio:SetChecked(true)
		RR_RollCheckBox_RankPrio_panel:SetChecked(true)
	end
	
	if RR_ShowGroupNumber == nil or RR_ShowGroupNumber == false then
		RR_ShowGroupNumber = false
		RR_RollCheckBox_ShowGroupNumber_panel:SetChecked(false)
	else
		RR_ShowGroupNumber = true
		RR_RollCheckBox_ShowGroupNumber_panel:SetChecked(true)
	end


	RR_Next:Disable()
	RR_Last:Disable()
	
-- This controls the showing of the window (true = show window, false = dont show window)
	if RR_Roll_Tracking_Enabled == nil then
		RR_Roll_Tracking_Enabled = true
	end
	
	if RR_Roll_Tracking_Enabled == false then
		ChatFrame1:AddMessage("Raid Roll: Raid Roll Tracking disabled. Type ''/rr enable'' to enable tracking")
	end
	
-- sets up the name frame
	--RR_SetupNameFrame()
	
	if RR_RollFrameHeight == nil then
		RR_RollFrameHeight = RR_RollFrame:GetHeight()
	end
	
	RR_RollFrame:SetHeight(RR_RollFrameHeight)
	RR_RollWindowSizeUpdated()
	RaidRoll_CheckButton_Update()
	RaidRoll_CheckButton_Update_Panel()
end


	-- /run RR_ExtraWidth=300
	-- /run RaidRoll_CheckButton_Update()

